indexing

	description: "Class that covers Posix shared memory routines."

	usage: "A shared memory object basically is a FILE_DESCRIPTOR."

	author: "Berend de Boer"
	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #3 $"

class

	POSIX_SHARED_MEMORY


inherit

	POSIX_FILE_DESCRIPTOR
		export {NONE}
			make_as_duplicate,
			make_from_file,
			ttyname
		redefine
			do_open,
			do_create
		end

	PAPI_MMAN


creation

	open_read,
	open_read_write,
	create_write,
	create_read_write


feature {NONE} -- Internal open/create

	do_open (a_path: STRING; flags: INTEGER) is
		local
			cpath: POINTER
			a_fd: INTEGER
		do
			path.make_from_string (a_path)
			cpath := sh.string_to_pointer (path)
			a_fd := posix_shm_open (cpath, flags, 0)
			if a_fd = -1 then
				raise_posix_error
			end
			set_fd (a_fd, True)
			-- file offset is unspecified, do a seek?
		end

	do_create (a_path: STRING; flags, mode: INTEGER) is
		local
			cpath: POINTER
			a_fd: INTEGER
		do
			path.make_from_string (a_path)
			cpath := sh.string_to_pointer (path)
			a_fd := posix_shm_open (cpath, flags, mode)
			if a_fd = -1 then
				raise_posix_error
			end
			set_fd (a_fd, True)
			-- file offset is unspecified, do a seek?
		end


end
