indexing

	description: "ISE conversion of strings to pointers and vice versa."
	thanks: "The mico/E team for the idea."

	date: "$Date: 2003/01/09 $"
	revision: "$Revision: #3 $"

class

	EPX_STRING_HELPER


inherit

	ABSTRACT_STRING_HELPER


feature -- ISE specific conversions

	string_to_pointer (s: STRING): POINTER is
		local
			a: ANY
			pr: POINTER_REF
		do
			if s = Void then
				Result := default_pointer
			else
				a := s.to_c
				!! pr
				pr.set_item ($a)
				Result := pr.item
				-- at least the GC won't remove it, but it can still move it.
				-- is this the best way to handle this?
				-- or is this code safe already??
				store_string (s)
				-- perhaps I should just copy the string to a buffer I'm
				-- sure will never move.
			end
		end

	pointer_to_string (p: POINTER): STRING is
		do
			if p = default_pointer then
				Result := ""
			else
				!! Result.make_from_c (p)
			end
		end

	set_string_from_pointer (s: STRING; p: POINTER) is
		do
			if p = default_pointer then
				s.clear_all
			else
				s.make_from_c (p)
			end
		end


feature -- String utilities that have different names per compiler...

	make_with_capacity (capacity: INTEGER): STRING is
			-- create a new string
		do
			create Result.make (capacity)
		end


end
