indexing

   description: "Class that gets windows stat structure through stat call."

   author: "Berend de Boer"
   date: "$Date: 2002/02/06 $"
   revision: "$Revision: #2 $"

class

   WINDOWS_STATUS_PATH


inherit

   WINDOWS_STATUS

   ABSTRACT_STATUS_PATH

   WAPI_STAT


creation {EPX_FILE_SYSTEM}

   make


feature {NONE} -- abstract API

   abstract_stat (a_path: POINTER; a_stat: POINTER): INTEGER is
         -- Gets information about a file
      do
         Result := posix_stat (a_path, a_stat)
      end


feature {NONE} -- abstract stat member functions

   abstract_st_atime (a_stat: POINTER): INTEGER is
         -- time of last access
      do
         Result := posix_st_atime (a_stat)
      end

   abstract_st_ctime (a_stat: POINTER): INTEGER is
         -- time of last status change
      do
         Result := posix_st_ctime (a_stat)
      end

   abstract_st_dev (a_stat: POINTER): INTEGER is
         -- Drive number of the disk containing the file
      do
         Result := posix_st_dev (a_stat)
      end

   abstract_st_mode (a_stat: POINTER): INTEGER is
      do
         Result := posix_st_mode (a_stat)
      end

   abstract_st_mtime (a_stat: POINTER): INTEGER is
         -- time of last data modification
      do
         Result := posix_st_mtime (a_stat)
      end

   abstract_st_nlink (a_stat: POINTER): INTEGER is
         -- number of hard links
      do
         Result := posix_st_nlink (a_stat)
      end

   abstract_st_size (a_stat: POINTER): INTEGER is
         -- total size, in bytes
      do
         Result := posix_st_size (a_stat)
      end

   abstract_stat_size: INTEGER is
         -- return size of struct stat
      do
         Result := posix_stat_size
      end


feature {NONE} -- test file type bits

   abstract_s_ischr (m: INTEGER): BOOLEAN is
      do
         Result := posix_s_ischr (m)
      end

   abstract_s_isdir (m: INTEGER): BOOLEAN is
      do
         Result := posix_s_isdir (m)
      end

   abstract_s_isfifo (m: INTEGER): BOOLEAN is
      do
         Result := posix_s_isfifo (m)
      end

   abstract_s_isreg (m: INTEGER): BOOLEAN is
      do
         Result := posix_s_isreg (m)
      end


end -- class WINDOWS_STATUS_PATH
